<?php
/****************************************************************************
*    Copyright (C) 2000 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************/ 

/**************************************************************************
** name: get_price($product_id)
** created by:
** description: gets price for a given product Id based on
**              the shopper group a user belongs to and whether
**              and item has a price or it must grab it from the 
**              parent.
** parameters:
** returns:
***************************************************************************/
function get_price($product_id) {
  global $auth, $ps_product;
  $db = new ps_DB;

  // Get the vendor id for this product.
  $q = "SELECT vendor_id FROM product WHERE product_id='$product_id'";
  $db->query($q);
  $db->next_record();
  $vendor_id = $db->f("vendor_id");

  // Get the shopper group id for this product and user
  $q = "SELECT shopper_group_id FROM shopper_vendor_xref WHERE ";
  $q .= "user_id='";
  $q .= $auth->auth["uid"] . "' AND vendor_id='$vendor_id'";
  $db->query($q);
  $db->next_record();
  $shopper_group_id = $db->f("shopper_group_id");

  // Get the default shopper group id for this product and user
  $q = "SELECT * FROM shopper_group WHERE ";
  $q .= "vendor_id='$vendor_id' AND ";
  $q .= "shopper_group_name='-default-'";
  $db->query($q);
  $db->next_record();
  $default_shopper_group_id = $db->f("shopper_group_id");

  // Get the product_parent_id for this product/item
  $product_parent_id = $ps_product->get_field($product_id, "product_parent_id");


  // Getting prices
  //
  // If the shopper group has a price then show it, otherwise
  // show the default price.
  $q = "SELECT * from product_price WHERE product_id='$product_id' AND ";
  $q .= "shopper_group_id='$shopper_group_id'";
  $db->query($q);
  if ($db->next_record()) {
     $price_info["product_price"]=$db->f("product_price");
     $price_info["product_currency"]=$db->f("product_currency");
     $price_info["item"]=True;
     return $price_info;
  }

  // Get default price
  $q = "SELECT * from product_price WHERE product_id='$product_id' AND ";
  $q .= "shopper_group_id='$default_shopper_group_id'";
  $db->query($q);
  if ($db->next_record()) {
     $price_info["product_price"]=$db->f("product_price");
     $price_info["product_currency"]=$db->f("product_currency");
     $price_info["item"]=True;
     return $price_info;
  }

  // Maybe its an item with no price, check again with product_parent_id
  $q = "SELECT * from product_price WHERE product_id='$product_parent_id' AND ";
  $q .= "shopper_group_id='$shopper_group_id'";
  $db->query($q);
  if ($db->next_record()) {
     $price_info["product_price"]=$db->f("product_price");
     $price_info["product_currency"]=$db->f("product_currency");
     return $price_info;
  }

  $q = "SELECT * from product_price WHERE product_id='$product_parent_id' AND ";
  $q .= "shopper_group_id='$default_shopper_group_id'";
  $db->query($q);
  if ($db->next_record()) {
     $price_info["product_price"]=$db->f("product_price");
     $price_info["product_currency"]=$db->f("product_currency");
     return $price_info;
  }

  // No price found
  return False;
}

/**************************************************************************
** name: show_image
** created by: pablo
** description: displays an image based on the vendor_id, value of the
**              image path and path
** parameters:
** returns:
***************************************************************************/
function show_image($vendor_id, $image_field, $path) {
   global $ps_vendor;

   echo "<IMG BORDER=0 SRC=";
   echo $ps_vendor->get_field($vendor_id,"vendor_image_path");
   echo $path . "/";
   echo $image_field . ">";
   return True;
}

/**************************************************************************
** name: list_attribute($product_id, $attribute_name)
** created by: pablo
** description: 
** parameters: product_id (may be a product or item)
** returns:
***************************************************************************/
function list_attribute($product_parent_id, $attribute_name, $title, $product_id=0) {

    // Creates a form drop down list and prints it
    $db = new ps_DB;

   
    // Check if  
    $q = "SELECT count(*) as rowcnt FROM product,product_attribute where";
    $q .= " product.product_parent_id='$product_parent_id' AND";
    $q .= " product_attribute.attribute_name='$attribute_name'";
    $db->query($q);
    $db->next_record();
    $rowcnt = $db->f("rowcnt");

    if ( $rowcnt > 0) {
      $q = "SELECT * FROM product, product_attribute where";
      $q .= " product.product_parent_id='$product_parent_id' AND";
      $q .= " product_attribute.attribute_name='$attribute_name' AND";
      $q .= " product.product_id=product_attribute.product_id order by"; 
      $q .= " product_attribute.attribute_value ASC";
      $db->query($q);

      $code = "<select name=product_id>\n";
      $code .= "<option value=\"0\">$title</option>\n";
      while ($db->next_record()) {
        $code .= "  <option value=\"" . $db->f("product_id") . "\"";
        if ($product_id == $db->f("product_id"))
           $code.= " SELECTED";
        $code .= ">" . $db->f("attribute_value") . "</option>\n";
      }
      $code .= "</select>\n";
    }
    else {
      $code = "<INPUT TYPE=HIDDEN NAME=product_id VALUE=$product_parent_id>\n";
    }
      print $code;
  }

/**************************************************************************
** name: validate_image
** created by: jep
** description: Validates an uploaded image. Creates UNIX commands to be used
**              by the process_images function, which has to be called after
**              the validation.
**
** parameters: 
**   - $d             The array containing a the image upload information.
**       - $d[$field_name] : PHP passes the local temp filename for the image
**                           upload here.
**       - $d[$field_name . "_name"] : PHP passes the original filename of the
**                                     uploaded  file here.
**       - $d[$field_name . "_curr"] : This must be passed by the form that
**                                     uploads the images.  It must contain
**                                     the filename of the current image for
**                                     the field_name.
**
**   - $field_name    The name of the field in the data base that is used to
**                    store the image filename.  This name has to be the one
**                    used in the Upload Form Object so that all image upload
**                    vars can be accessed from the $d array.
**
**   - $table_name    The name of the table where the image belongs.  This 
**                    variable indicates the subdirectory where the image 
**                    files will be placed. This directory is based on the
**                    vendor_image_path value found on the vendor table in
**                    the database.
**
** returns:
**   - If an image upload was not requested for field_name, the function
**     returns TRUE.
**
**   - If an image upload was requested for field_name:
**       - TRUE if image was uploaded to the local drive, the file is readable,
**         the image type is valid, and the destination directory is writeable.
**       - FALSE otherwise.
**
**   - If an image delete was requested:
**       - TRUE if the directory is writeable.
**       - FALSE otherwise.
**
**   - $d["$field_name"] : The filename (without path) to where
**                         the image was saved is returned here.
**
**   - $d["image_commands"] : The commands to be executed by the process_images
**                           function are returned as a string here.  The
**                           commands are UNIX commands separated by ";"
**
**   - $d["error"] : Error messages returned here.
**                         
***************************************************************************/  
function validate_image(&$d,$field_name,$table_name) {
  global $ps_vendor_id, $ps_vendor; 
  $temp_file = $d[$field_name];
  $orig_file = $d[$field_name . "_name"];
  $curr_file = $d[$field_name . "_curr"];
  $file_size = $d[$field_name . "_size"];
 
  /* If nothing was entered in the Upload box, there is no image to
  ** process */
  if (!$orig_file) {
    $d[$field_name] = $curr_file;
    return true;
  } 

  /* Generate text to dispaly in error messages */
  if (eregi("thumb",$field_name)) {
    $image_type = "thumbnail image";
  } elseif (eregi("full",$field_name))  {
    $image_type = "full image";
  } else {
    $image_type = ereg_replace("_"," ",$field_name);
  }

  /* Generate the path to images */
  $path  = WEBROOT;
  if ($d["vendor_image_path"]) {
    $path .= $d["vendor_image_path"];
  } elseif ($ps_vendor_id) {
    $path .= $ps_vendor->get_field($ps_vendor_id,"vendor_image_path");
  } elseif ($d["vendor_id"]) {
    $path .= $ps_vendor->get_field($d["vendor_id"],"vendor_image_path");
  } else {
    $d["error"] .= "ERROR:process_image: Could not resolve vendor image ";
    $d["error"] .= "path.<BR>";
    return false;
  }
  $path .= $table_name . "/";

  /* If User types "none" in Image Upload Field */
  if ($orig_file == "none") {
    /* If there is a current image file */
    if ($curr_file) {
      /* Check permissions to delete from $path */
      $c = "test -w $path";
      exec($c,$dummy,$ret); 
      if ($ret != 0) {
         $d["error"] .= "ERROR: Cannot delete from $image_type directory.";
         $d["error"] .= "<BR>$path<BR>";
         return false;
      } else {
        $d["image_commands"] .= "rm -f $path$curr_file;";
      }
    }
  $d[$field_name] = "";
  return true;
  }

  /* If upload fails */
  elseif($orig_file and $temp_file == "none") {
    $d["error"] .= "ERROR: $image_type upload failed.";
    return false;
  }

  /* Check permissions to read temp file */
  $c = "test -r $temp_file";
  exec($c,$dummy,$ret); 
  if ($ret != 0) {
    $d["error"] .= "ERROR: Cannot read uploaded $image_type temp file.<BR>";
    return false;
  }

  /* Generate Image Destination File Name */
  $to_file = md5(uniqid("PHPShop"));

  /* Check image file format */
  $image_info = getimagesize($temp_file);
  switch($image_info[2]) {
    case 1:
         $to_file .= ".gif";
         break;
    case 2:
         $to_file .= ".jpg";
         break;
    default:
         $d["error"] .= "ERROR: $image_type file is invalid.<BR>";
	 return false;
  }

  /*
  ** If it gets to this point then there is an uploaded file in the system
  ** and it is a valid image file.
  */

  /* Check permissions to write to destination directory */
  $c = "test -w $path";
  exec($c,$dummy,$ret); 
  if ($ret != 0) {
    $d["error"] .= "ERROR: Cannot write to $image_type destination ";
    $d["error"] .= "directory.<BR>$path<BR>";
    return false;
  }

  /* If Updating */
  if ($curr_file) {
    /* Command to remove old image file */
    $d["image_commands"] .= "rm -f $path$curr_file;";
  }

  /* Command to move uploaded file into destination directory */
  $d["image_commands"] .= "mv $temp_file $path$to_file;";

  /* Return new image file name */
  $d[$field_name] = $to_file;
  return true;
}

/**************************************************************************
** name: process_images
** created by: jep
** description: 
** parameters:
** returns:
***************************************************************************/  
function process_images(&$d) {
  if ($d["image_commands"]) {
    $commands = explode(";",ereg_replace(";$","",$d["image_commands"]));
    $d["image_commands"] = "";
    $cnt = count($commands);
    for ($i=0;$i<$cnt;$i++) {
      exec($commands[$i],$dummy,$ret); 
      if ($ret != 0) {
        $d["error"] .= "ERROR: Image Update command failed.<BR>";
        $d["error"] .= $commands[$i] . "<BR>";
        return false;
      }
    }
  }
  return true;
}

/**************************************************************************
** name: process_date_time
** created by: jep
** description: 
** parameters:
** returns:
***************************************************************************/  
function process_date_time(&$d,$field,$type="") {
  $month = $d["$field" . "_month"];
  $day = $d["$field" . "_day"];
  $year = $d["$field" . "_year"];
  $hour = $d["$field" . "_hour"];
  $minute = $d["$field" . "_minute"];
  $use = $d["$field" . "_use"];
  $valid = true;

  /* If user unchecked "Use date and time" then time = 0 */
  if (!$use) {
    $d[$field] = 0;
    return true;
  }
  if (!checkdate($month,$day,$year)) {
    $d["error"] .= "ERROR: $type date is invalid.";
    $valid = false;
  }
  if (!$hour and !$minute) {
    $hour = 0;
    $minute = 0;
  } elseif ($hour < 0 or $hour > 23 or $minute < 0 or $minute > 59) {
    $d["error"] .= "ERROR: $type time is invalid.";
    $valid = false;
  }

  if ($valid) {
    $d[$field] = mktime($hour,$minute,0,$month,$day,$year);
  }

  return $valid;   
}

/****************************************************************************
 *    function: validate_email
 *  created by: Gregory Day
 * description: Validates an e-mail address.  Only checks that the format
 *              is valid.  It does not validate that the address will
 *              work.
 *  parameters: $email: Email address to validate
 *     returns: true: Email address is valid
 *             false: Email address is not valid
 ****************************************************************************/
function validate_email ( $email ) {

   if(ereg('^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$', $email)) {      return(true);
   }
   else {
      return(false);
   }
} // validate_email()


?>
