<?php
/****************************************************************************
*    Copyright (C) 2000 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************
*
* CLASS DESCRIPTION
*                   
* ps_class
*
* The class is
* 
* propeties:  
* 	
*       error - the error message returned by validation if any
* methods:
*       validate_add()
*	validate_delete()
*	validate_update()
*       add()
*       update()
*       delete()
*	
*
*************************************************************************/
class ps_shopper_group {
  var $classname = "ps_shopper_group";
  var $id = "";
  var $error;
  
  /**************************************************************************
  ** name: validate
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/    function validate_add($d) {
    $db = new ps_DB;
    global $ps_vendor_id;
    
    if (!$d["shopper_group_name"]) {
      $this->error = "ERROR:  You must enter a shopper group name.";
      return False;	
    }
    elseif ($d["shopper_group_name"]) {
      $q = "SELECT count(*) as num_rows from shopper_group";
      $q .= " WHERE shopper_group_name='" . $d["shopper_group_name"] . "'";
      $q .= " AND vendor_id='" . $ps_vendor_id . "'";

      $db->query($q);
      $db->next_record();
      if ($db->f("num_rows") > 0) {
	$this->error = "ERROR:  Shopper group already exists for this vendor.";
	return False;
      }
      else {
	return True;
      }
    }
  }
  
  /**************************************************************************
  ** name: validate
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/    function validate_delete($d) {

    if (!$d["shopper_group_id"]) {
      $this->error = "ERROR:  Please select a shopper group to delete.";
      return False;
    }
    else {
      return True;
    }
  }

  /**************************************************************************
  ** name: validate
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/    function validate_update($d) {
    
    if (!$d["shopper_group_name"]) {
      $this->error = "ERROR:  You must enter a shopper group name.";
      return False;	
    }
    else {
      return True;
    }
  }
  
  
  /**************************************************************************
   * name: add()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function add(&$d) {
    global $ps_vendor_id;
    $hash_secret = "PHPShopIsCool";
    $db = new ps_DB;
    $timestamp = time();
    
    if ($this->validate_add($d)) {
      $user_id=md5(uniqid($hash_secret));
      
      $q = "INSERT INTO shopper_group (shopper_group_name, shopper_group_desc, vendor_id) ";
      $q .= "VALUES ('";
      $q .= $d["shopper_group_name"] . "','";
      $q .= $d["shopper_group_desc"] . "','";
      $q .= $ps_vendor_id . "')";
      $db->query($q);
      $db->next_record();
      
      $q = "SELECT * from shopper_group where";
      $q .= " shopper_group_name='";
      $q .= $d["shopper_group_name"] . "' ";
      $q .= "AND shopper_group_desc='" . $d["shopper_group_desc"] ."'";
      $q .= "AND vendor_id='" . $ps_vendor_id ."'";
      $db->query($q);
      $db->next_record();
      return $db->f("shopper_group_id");
    }
      else {
	$d["error"]=$this->error;
	return False;
      }
  }

  /**************************************************************************
   * name: update()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function update($d) {
    global $ps_vendor_id;
    $db = new ps_DB;
    $timestamp = time();

    if ($this->validate_update($d)) {
      
      $q = "UPDATE shopper_group set shopper_group_name='" . $d["shopper_group_name"] . "', ";
      $q .= "shopper_group_desc='" . $d["shopper_group_desc"] . "', ";
      $q .= "vendor_id='" . $ps_vendor_id . "' ";
      $q .= "WHERE shopper_group_id='" . $d["shopper_group_id"] . "'";
      $db->query($q);
      $db->next_record();
      return True;
    }
    else {
      $d["error"] = $this->error;
      return True;
    }
  }

  /**************************************************************************
   * name: delete()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function delete(&$d) {
    $db = new ps_DB;
    
    if ($this->validate_delete($d)) {
      $q = "DELETE from shopper_group where shopper_group_id='" . $d["shopper_group_id"] . "'";
      $db->query($q);
      $db->next_record();
      return True;
    }
    else {
      $d["error"] = $this->error;
      return True;
    }
  }
  
  /**************************************************************************
  ** name: list_shopper_groups
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/
  function list_shopper_groups($name,$shopper_group_id=0,$product_id=0) {
    global $ps_vendor_id;
    $db = new ps_DB;
    
    echo "<SELECT NAME=$name>\n";

    $q  = "SELECT shopper_group_id,shopper_group_name from shopper_group ";
    $q .= "WHERE vendor_id = '$ps_vendor_id' ";
    $q .= "ORDER BY shopper_group_name";
    $db->query($q);
    while ($db->next_record()) {
      if ($db->f("shopper_group_id") == $shopper_group_id) {
        echo "<OPTION VALUE=" . $db->f("shopper_group_id")  . " SELECTED>";
        echo $db->f("shopper_group_name") . "</OPTION>\n";
      } elseif (!$product_id) {
        echo "<OPTION VALUE=" . $db->f("shopper_group_id")  . ">";
        echo $db->f("shopper_group_name") . "</OPTION>\n";
      } else {
        $db2 = new ps_DB;
        $q2  = "SELECT shopper_group_id FROM product_price ";
        $q2 .= "WHERE shopper_group_id = '" . $db->f("shopper_group_id") . "' ";
        $q2 .= "AND product_id = '$product_id' ";
        $db2->query($q2);
        if (!$db2->next_record()) {
          echo "<OPTION VALUE=" . $db->f("shopper_group_id")  . ">";
          echo $db->f("shopper_group_name") . "</OPTION>\n";
        }
      } 
    }
    echo "</SELECT>\n";
  }        
  
  /**************************************************************************
  ** name: get_field
  ** created by: pablo
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/
  function get_field($shopper_group_id, $field_name) {
    $db = new ps_DB;

    $q =  "SELECT $field_name FROM shopper_group ";
    $q .= "WHERE shopper_group_id='$shopper_group_id'";
    $db->query($q);
    if ($db->next_record()) {
       return $db->f($field_name);
    }
    else {
       return False;
    }
  }

}

?>
