<?php
/****************************************************************************
*    Copyright (C) 2000 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************/ 

class ps_user {
  var $classname = "ps_user";
  var $error;
  
  function validate_add($d) {
    
    if (!$d["last_name"]) {
      $this->error = "You must enter a last name for the user.";
      return False;	
    }
    if (!$d["first_name"]) {
      $this->error = "You must enter a first name for the user.";
      return False;	
    }
    if (!$d["username"]) {
      $this->error = "You must enter a username for the user.";
      return False;	
    }
    if (!$d["password_1"]) {
      $this->error = "You must enter a password for the user.";
      return False;		
    }
    if ($d["password_1"] != $d["password_2"]) {
      $this->error = "The passwords entered do not match.";
      return False;		
    }
    if (!$d["perms"]) {
      $this->error = "You must assign the user to a group.";
      return False;	
    }
    if (!$d["user_email"]) {
      $this->error = "Please provide an email address.";
      return False;
    }
    if (!validate_email($d["user_email"])) {
      $this->error = "Please provide a valid email address.";
      return False;
    }
    $db = new ps_DB;
    $q = "SELECT * from auth_user_md5 where username='" .  $d["username"] . "'";
    $db->query($q);
    if ($db->next_record()) {
      $this->error = "The given username already exists.  ";
      $this->error .= "Please try another username.";
      return False;
    }
    return True;
  }
  
  function validate_delete($d) {

    if (!$d["user_id"]) {
      $this->error = "Please select a user to delete.";
      return False;
    }
    else {
      return True;
    }
  }

  function validate_update($d) {
    
    if (!$d["last_name"]) {
      $this->error = "You must enter a last name for the user.";
      return False;	
    }
    if (!$d["first_name"]) {
      $this->error = "You must enter a first name for the user.";
      return False;	
    }
    if (!$d["username"]) {
      $this->error = "You must enter a username for the user.";
      return False;	
    }
    if ($d["password_1"] != $d["password_2"]) {
      $this->error = "The passwords entered do not match.";
      return False;		
    }
    if (!$d["user_email"]) {
      $this->error = "Please provide an email address.";
      return False;
    }
    if (!validate_email($d["user_email"])) {
      $this->error = "Please provide a valid email address.";
      return False;
    }
    return True;
  }
  
  
  /**************************************************************************
   * name: add()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function add(&$d) {
    global $ps_vendor_id;
    $hash_secret = "PHPShopIsCool";
    $db = new ps_DB;
    $timestamp = time();
    
    if (!$this->validate_add($d)) {
      $d["error"] = $this->error;
      return False;
    }
    
    $user_id=md5(uniqid($hash_secret));
    
    $q = "INSERT INTO auth_user_md5 (user_id,username,password, perms) ";
    $q .= "VALUES ('";
    $q .= $user_id . "','";
    $q .= $d["username"] . "','";
    $q .= md5($d["password_1"]) . "','";
    $q .= $d["perms"] . "')";
    $db->query($q);
    $db->next_record();
    
    // Insert billto
    $q = "INSERT INTO user_info (user_id,address_type, address_type_name,";
    $q .= "company, title, last_name, first_name,middle_name,";
    $q .= "phone_1, phone_2, fax, address_1,";
    $q .= "address_2, city, state, country, zip,";
    $q .= "user_email, cdate, mdate) VALUES ";
    $q .= "('" . $user_id . "','";
    $q .= $d["address_type"] . "','";
    $q .= $d["address_type_name"] . "','";
    $q .= $d["company"] . "','";
    $q .= $d["title"] . "','";
    $q .= $d["last_name"] . "','";
    $q .= $d["first_name"] . "','";
    $q .= $d["middle_name"] . "','";
    $q .= $d["phone_1"] . "','";
    $q .= $d["phone_2"] . "','";
    $q .= $d["fax"] . "','";
    $q .= $d["address_1"] . "','";
    $q .= $d["address_2"] . "','";
    $q .= $d["city"] . "','";
    $q .= $d["state"] . "','";
    $q .= $d["country"] . "','";
    $q .= $d["zip"] . "','";
    $q .= $d["user_email"] . "','";
    $q .= time() . "','";
    $q .= time() . "') ";
    $db->query($q);
    $db->next_record();
    
    // Insert copy of billto as default shipto
    $q = "INSERT INTO user_info (user_id,address_type, address_type_name,";
    $q .= "company, title, last_name, first_name,middle_name,";
    $q .= "phone_1, phone_2, fax, address_1,";
    $q .= "address_2, city, state, country, zip,";
    $q .= "user_email, cdate, mdate) VALUES ";
    $q .= "('" . $user_id . "','";
    $q .= "ST','";
    $q .= "Default-BillTo','";
    $q .= $d["company"] . "','";
    $q .= $d["title"] . "','";
    $q .= $d["last_name"] . "','";
    $q .= $d["first_name"] . "','";
    $q .= $d["middle_name"] . "','";
    $q .= $d["phone_1"] . "','";
    $q .= $d["phone_2"] . "','";
    $q .= $d["fax"] . "','";
    $q .= $d["address_1"] . "','";
    $q .= $d["address_2"] . "','";
    $q .= $d["city"] . "','";
    $q .= $d["state"] . "','";
    $q .= $d["country"] . "','";
    $q .= $d["zip"] . "','";
    $q .= $d["user_email"] . "','";
    $q .= time() . "','";
    $q .= time() . "') ";
    $db->query($q);
    $db->next_record();

    // Insert vendor relationship
    $q = "INSERT INTO auth_user_vendor (user_id,vendor_id)";
    $q .= " VALUES ";
    $q .= "('" . $user_id . "','";
    $q .= $d["vendor_id"] . "') ";
    $db->query($q);
    $db->next_record();
    
    return True;
    
  }
  
  /**************************************************************************
   * name: update()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function update(&$d) {
    global $ps_vendor_id;
    $db = new ps_DB;
    $timestamp = time();
    
    
    if (!$this->validate_update($d)) {
      $d["error"] = $this->error;
      return False;
    }
    
    if ($d["password_1"]) {
      $d["password_1"] = md5($d["password_1"]);
      $q = "UPDATE auth_user_md5 set password='" . $d["password_1"];
      $q .= "', perms='" . $d["perms"] . "', ";
      $q .= "username='" . $d["username"] . "' ";
      $q .= "WHERE user_id='" . $d["user_id"] . "'";      
      $db->query($q);
      $db->next_record();
    }
    else {
      $q = "UPDATE auth_user_md5 set perms='" . $d["perms"] . "', ";
      $q .= "username='" . $d["username"] . "' ";
      $q .= "WHERE user_id='" . $d["user_id"] . "'";      
      $db->query($q);
      $db->next_record();
    }
    
    $q = "UPDATE user_info set company='" . $d["company"] . "', ";
    $q .= "address_type='" . $d["address_type"] . "', ";
    $q .= "address_type_name='" . $d["address_type_name"] . "', ";
    $q .= "title='" . $d["title"] . "', ";
    $q .= "last_name='" . $d["last_name"] . "', ";
    $q .= "first_name='" . $d["first_name"] . "', ";
    $q .= "middle_name='" . $d["middle_name"] . "', ";
    $q .= "phone_1='" . $d["phone_1"] . "', ";
    $q .= "phone_2='" . $d["phone_2"] . "', ";
    $q .= "fax='" . $d["fax"] . "', ";
    $q .= "address_1='" . $d["address_1"] . "', ";
    $q .= "address_2='" . $d["address_2"] . "', ";
    $q .= "city='" . $d["city"] . "', ";
    $q .= "state='" . $d["state"] . "', ";
    $q .= "country='" . $d["country"] . "', ";
    $q .= "zip='" . $d["zip"] . "', ";
    $q .= "user_email='" . $d["user_email"] . "', ";
    $q .= "mdate='" . time() . "' ";
    $q .= "WHERE user_id='" . $d["user_id"] . "' AND ";
    $q .= "address_type='BT'";
    $q .= $q_end;
    $db->query($q);
    $db->next_record();

    $q = "UPDATE auth_user_vendor set ";
    $q .= "vendor_id='" . $d["vendor_id"] . "' ";
    $q .= "WHERE user_id='" . $d["user_id"] . "'";
    $db->query($q);
    $db->next_record();

    return True;
  }
  
  /**************************************************************************
   * name: delete()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function delete(&$d) {
    $db = new ps_DB;
    
    if (!$this->validate_delete($d)) {
      $d["error"] = $this->error;
      return False;
    }
    
    $q = "DELETE from auth_user_md5 where user_id='" . $d["user_id"] . "'";
    $db->query($q);
    $db->next_record();
    
    $q = "DELETE from user_info where user_id='" . $d["user_id"] . "'";
    $db->query($q);
    $db->next_record();

    // Delete auth_user_vendor entries
    $q = "DELETE from auth_user_vendor where user_id='" . $d["user_id"] . "'";
    $db->query($q);
    $db->next_record();

    return True;
  }
  
  
  /**************************************************************************
   * name: find()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function find($d, $start=0) {
    $db = new ps_DB;
    

    $q = "SELECT * from auth_user_md5,user_info where ";
    $q .= "auth_user_md5.username LIKE '%" . $d["username"] . "%' AND ";
    $q .= "user_info.customer_no LIKE '%" . $d["customer_no"] . "%' AND ";
    $q .= "user_info.name LIKE '%" . $d["customer_name"] . "%' AND ";
    $q .= "user_info.address1 LIKE '%" . $d["address_1"] . "%' AND ";
    $q .= "user_info.address2 LIKE '%" . $d["address_2"] . "%' AND ";
    $q .= "user_info.city LIKE '%" . $d["city"] . "%' AND ";
    $q .= "user_info.state LIKE '%" . $d["state"] . "%' AND ";
    $q .= "user_info.zipcode LIKE '%" . $d["zipcode"] . "%' AND ";
    $q .= "user_info.country LIKE '%" . $d["country"] . "%' AND ";
    $q .= "user_info.dayphone LIKE '%" . $d["dayphone"] . "%' AND ";
    $q .= "user_info.evephone LIKE '%" . $d["evephone"] . "%' AND ";
    $q .= "auth_user_md5.user_id = user_info.user_id";
    $db->query($q);
    $db->next_record();
    if ($db->nf() == 1) {
      return "?id=" . $db->f("user_id");
    }
    $t = new phpshop_Table;
    $t->query = $q;
    $t->start=$start;
    // Select fields to display
    $t->fields = array(
		       "username",
		       "name",
		       "address1",
		       "city",
		       "dayphone"
		       );
    
    // Set column header names
    $t->map_cols = array(
			 "username" => "UserName",
			 "name" => "Full Name",
			 "address1"=>"Address",
			 "city"=>"City",
			 "dayphone"=>"Phone"
			 );
    $t->show_table();
    return True;
  }


  /**************************************************************************
   * name: list_perms()
   * created by: pablo
   * description: lists the permission in a select box
   * parameters:
   * returns:
   **************************************************************************/
  function list_perms($name,$group_name) {
    global $perm;
    $db = new ps_DB;

    echo "<SELECT NAME=$name>\n";
    echo "<OPTION VALUE=\"0\">Please Select</OPTION>\n";
    while (list($key,$value) = each($perm->permissions)) {
      if ($key == $group_name) {
	echo "<OPTION VALUE=$key SELECTED>$key</OPTION>\n";
      }
      else {
	echo "<OPTION VALUE=$key>$key</OPTION>\n";
      }
    }
    echo "</SELECT>\n";
  }        

  /**************************************************************************
   * name: logout()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function logout($d) {
    global $auth, $sess;
    
    $auth->unauth("True");
    $sess->unregister("ps_vendor_id");
    return True;   
  }

  /**************************************************************************
   * name: login()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function login(&$d) {
    global $auth, $sess, $ps_vendor_id;
    $db = new ps_DB;

     $db->query(sprintf("select user_id,perms,password ".
                "from %s where username = '%s' and password='%s'",
                          $auth->database_table,
                          addslashes($d["username"]), md5($d["password"])));

    if ($db->next_record()) {
      $auth->auth["uid"]   = $db->f("user_id");
      $auth->auth["uname"] = $d["username"];
      $auth->auth["exp"] = $d["username"];
      $auth->auth["perm"]  = $db->f("perms");
    }
    else {
      $d["error"] = "The username and password you entered were not found.  Please try again.";
      return False;
    }

    // For single store functionality.  Will set user to vendor_id upon login
    // This will need to be looked at for MALL functionality
    if ($auth->auth["perm"] == "shopper")
      $q = "SELECT vendor_id FROM shopper_vendor_xref WHERE user_id='" . $auth->auth["uid"] . "'";
    else
      $q = "SELECT vendor_id FROM auth_user_vendor WHERE user_id='" . $auth->auth["uid"] . "'";
    $db->query($q);

    if ($db->next_record()) {
       $ps_vendor_id=$db->f("vendor_id");
       $sess->register("ps_vendor_id");
    }
    page_close();
    return $uid;

  }

  
}

?>
